package org.gcube.vremanagement.smartexecutor.sweeper;

import java.util.Map;

import org.gcube.vremanagement.executor.plugin.Plugin;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author Luca Frosini (ISTI - CNR) http://www.lucafrosini.com/
 */
public class ScheduledTaskSweeperPlugin extends Plugin<ScheduledTaskSweeperPluginDeclaration> {

	/**
	 * Logger
	 */
	private static Logger logger = LoggerFactory.getLogger(ScheduledTaskSweeperPlugin.class);
	
	public ScheduledTaskSweeperPlugin(ScheduledTaskSweeperPluginDeclaration pluginDeclaration) {
		super(pluginDeclaration);
		logger.debug("contructor");
	}
	
	/**{@inheritDoc}*/
	@Override
	public void launch(Map<String, Object> inputs) throws Exception {
		logger.debug("Launching {} execution", ScheduledTaskSweeperPluginDeclaration.NAME);
		// No inputs needed
		logger.debug("{} execution finished", ScheduledTaskSweeperPluginDeclaration.NAME);
	}

	/**{@inheritDoc}*/
	@Override
	protected void onStop() throws Exception {
		logger.debug("onStop()");
		
		Thread.currentThread().interrupt();
	}

}
